<!-- eslint-disable no-bitwise -->
<script lang="ts">
import {
  Component, Prop, Watch, Vue,
} from 'vue-property-decorator';
import type {
  Label, Rect, Staff, Unit, Pixel,
} from '@/data';

import { FilterStyleGenerator } from '@/logic/FilterStyleGenerator';
import type { Image3DPageData, SourceType } from '@/data/Source';
import { LabelRects } from './LabelRects';

@Component
export default class LabelWatcher extends Vue {
  @Prop({ required: true })
  readonly label!: Label;

  @Prop({ required: true })
  readonly staves!: Staff[];

  @Prop({ required: true })
  readonly pixelUnit!: Unit<Pixel>;

  @Prop({ required: true })
  readonly hasMargin!: boolean;

  @Prop({ default: false })
  readonly isSelected!: boolean;

  @Prop()
  readonly pages!: Array<Image3DPageData>;

  @Prop()
  readonly currentPage!: number;

  @Prop()
  readonly sourceType!: SourceType;

  // Default values not zeroed to avoid warnings
  rects: Rect[] = [{
    x: 0, y: 0, width: 10, height: 30,
  }] as Rect[];

  isMomentBar = false;

  renderCount = 0;

  mounted() {
    this.updateData();
  }

  /**
   * Watch all label properties that may cause a rerender
   */
  @Watch('label.duration')
  @Watch('label.onset')
  @Watch('label.staffId')
  @Watch('label.type')
  @Watch('label.tag')
  @Watch('isSelected')
  @Watch('staves')
  @Watch('pixelUnit')
  @Watch('hasMargin')
  /**
   * Also watch for point change, which happens only for SyncLabels in the SyncEditor
   */
  @Watch('label.point')
  updateRenderCount() {
    this.renderCount += 1;
  }

  @Watch('renderCount')
  updateData() {
    this.rects = new LabelRects(
      this.pixelUnit,
      this.label,
      this.sourceType,
      this.pages,
      this.hasMargin,
    ).value;

    this.isMomentBar = !this.label.duration && !this.hasMargin;

    this.classes = (this.label.duration ? '' : 'label-bar ')
      + (this.label.duration || this.hasMargin ? '' : 'moment-bar ')
      + (this.isSelected ? 'selected ' : '')
     + FilterStyleGenerator.getCssClassNames(this.label);
  }

  classes = '';
}
</script>
